if (!defined &__ASM_SPINLOCK_H) {
    eval 'sub __ASM_SPINLOCK_H () {1;}' unless defined(&__ASM_SPINLOCK_H);
    if (!defined &__SMP__) {
	eval 'sub SPIN_LOCK_UNLOCKED () {{ };}' unless defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub spin_lock_init {
	    local($lock) = @_;
	    eval " &do { }  &while(0)";
	}' unless defined(&spin_lock_init);
	eval 'sub spin_lock {
	    local($lock) = @_;
	    eval " &do { }  &while(0)";
	}' unless defined(&spin_lock);
	eval 'sub spin_trylock {
	    local($lock) = @_;
	    eval " &do { }  &while(0)";
	}' unless defined(&spin_trylock);
	eval 'sub spin_unlock_wait {
	    local($lock) = @_;
	    eval " &do { }  &while(0)";
	}' unless defined(&spin_unlock_wait);
	eval 'sub spin_unlock {
	    local($lock) = @_;
	    eval " &do { }  &while(0)";
	}' unless defined(&spin_unlock);
	eval 'sub spin_lock_irq {
	    local($lock) = @_;
	    eval " &cli()";
	}' unless defined(&spin_lock_irq);
	eval 'sub spin_unlock_irq {
	    local($lock) = @_;
	    eval " &sti()";
	}' unless defined(&spin_unlock_irq);
	eval 'sub spin_lock_irqsave {
	    local($lock, $flags) = @_;
	    eval " &do {  &save_flags($flags);  &cli(); }  &while (0)";
	}' unless defined(&spin_lock_irqsave);
	eval 'sub spin_unlock_irqrestore {
	    local($lock, $flags) = @_;
	    eval " &restore_flags($flags)";
	}' unless defined(&spin_unlock_irqrestore);
	eval 'sub RW_LOCK_UNLOCKED () {{ };}' unless defined(&RW_LOCK_UNLOCKED);
	eval 'sub read_lock {
	    local($lock) = @_;
	    eval " &do { }  &while(0)";
	}' unless defined(&read_lock);
	eval 'sub read_unlock {
	    local($lock) = @_;
	    eval " &do { }  &while(0)";
	}' unless defined(&read_unlock);
	eval 'sub write_lock {
	    local($lock) = @_;
	    eval " &do { }  &while(0)";
	}' unless defined(&write_lock);
	eval 'sub write_unlock {
	    local($lock) = @_;
	    eval " &do { }  &while(0)";
	}' unless defined(&write_unlock);
	eval 'sub read_lock_irq {
	    local($lock) = @_;
	    eval " &cli()";
	}' unless defined(&read_lock_irq);
	eval 'sub read_unlock_irq {
	    local($lock) = @_;
	    eval " &sti()";
	}' unless defined(&read_unlock_irq);
	eval 'sub write_lock_irq {
	    local($lock) = @_;
	    eval " &cli()";
	}' unless defined(&write_lock_irq);
	eval 'sub write_unlock_irq {
	    local($lock) = @_;
	    eval " &sti()";
	}' unless defined(&write_unlock_irq);
	eval 'sub read_lock_irqsave {
	    local($lock, $flags) = @_;
	    eval " &do {  &save_flags($flags);  &cli(); }  &while (0)";
	}' unless defined(&read_lock_irqsave);
	eval 'sub read_unlock_irqrestore {
	    local($lock, $flags) = @_;
	    eval " &restore_flags($flags)";
	}' unless defined(&read_unlock_irqrestore);
	eval 'sub write_lock_irqsave {
	    local($lock, $flags) = @_;
	    eval " &do {  &save_flags($flags);  &cli(); }  &while (0)";
	}' unless defined(&write_lock_irqsave);
	eval 'sub write_unlock_irqrestore {
	    local($lock, $flags) = @_;
	    eval " &restore_flags($flags)";
	}' unless defined(&write_unlock_irqrestore);
    }
    else {
	eval 'sub SPIN_LOCK_UNLOCKED () {{ 0, 0 };}' unless defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub spin_lock_init {
	    local($x) = @_;
	    eval " &do { ($x)-> &lock = 0; ($x)-> &previous = 0; }  &while(0)";
	}' unless defined(&spin_lock_init);
	eval 'sub spin_unlock_wait {
	    local($x) = @_;
	    eval " &do {  &barrier(); }  &while((( &volatile  &spinlock_t *)($x))-> &lock)";
	}' unless defined(&spin_unlock_wait);
	eval 'sub __dummy_lock {
	    local($lock) = @_;
	    eval "(*( &__dummy_lock_t *)($lock))";
	}' unless defined(&__dummy_lock);
	eval 'sub spin_lock {
	    local($lock) = @_;
	    eval " &__asm__  &__volatile__( \\"\\\\n1:\\\\t\\" \\"lock ; btsl $0,%0\\\\n\\\\t\\" \\"jc 2f\\\\n\\" \\".section .text.lock,\\\\\\"ax\\\\\\"\\\\n\\" \\"2:\\\\t\\" \\"testb $1,%0\\\\n\\\\t\\" \\"jne 2b\\\\n\\\\t\\" \\"jmp 1b\\\\n\\" \\".previous\\" :\\"=m\\" ( &__dummy_lock($lock)))";
	}' unless defined(&spin_lock);
	eval 'sub spin_unlock {
	    local($lock) = @_;
	    eval " &__asm__  &__volatile__( \\"lock ; btrl $0,%0\\" :\\"=m\\" ( &__dummy_lock($lock)))";
	}' unless defined(&spin_unlock);
	eval 'sub spin_trylock {
	    local($lock) = @_;
	    eval "(! &test_and_set_bit(0,($lock)))";
	}' unless defined(&spin_trylock);
	eval 'sub spin_lock_irq {
	    local($lock) = @_;
	    eval " &do {  &__cli();  &spin_lock($lock); }  &while (0)";
	}' unless defined(&spin_lock_irq);
	eval 'sub spin_unlock_irq {
	    local($lock) = @_;
	    eval " &do {  &spin_unlock($lock);  &__sti(); }  &while (0)";
	}' unless defined(&spin_unlock_irq);
	eval 'sub spin_lock_irqsave {
	    local($lock, $flags) = @_;
	    eval " &do {  &__save_flags($flags);  &__cli();  &spin_lock($lock); }  &while (0)";
	}' unless defined(&spin_lock_irqsave);
	eval 'sub spin_unlock_irqrestore {
	    local($lock, $flags) = @_;
	    eval " &do {  &spin_unlock($lock);  &__restore_flags($flags); }  &while (0)";
	}' unless defined(&spin_unlock_irqrestore);
	eval 'sub RW_LOCK_UNLOCKED () {{ 0, 0 };}' unless defined(&RW_LOCK_UNLOCKED);
	eval 'sub read_lock {
	    local($rw) = @_;
	    eval " &asm  &volatile(\\"\\\\n1:\\\\t\\" \\"lock ; incl %0\\\\n\\\\t\\" \\"js 2f\\\\n\\" \\".section .text.lock,\\\\\\"ax\\\\\\"\\\\n\\" \\"2:\\\\tlock ; decl %0\\\\n\\" \\"3:\\\\tcmpl $0,%0\\\\n\\\\t\\" \\"js 3b\\\\n\\\\t\\" \\"jmp 1b\\\\n\\" \\".previous\\" :\\"=m\\" ( &__dummy_lock(&($rw)-> &lock)))";
	}' unless defined(&read_lock);
	eval 'sub read_unlock {
	    local($rw) = @_;
	    eval " &asm  &volatile(\\"lock ; decl %0\\" :\\"=m\\" ( &__dummy_lock(&($rw)-> &lock)))";
	}' unless defined(&read_unlock);
	eval 'sub write_lock {
	    local($rw) = @_;
	    eval " &asm  &volatile(\\"\\\\n1:\\\\t\\" \\"lock ; btsl $31,%0\\\\n\\\\t\\" \\"jc 4f\\\\n\\" \\"2:\\\\ttestl $0x7fffffff,%0\\\\n\\\\t\\" \\"jne 3f\\\\n\\" \\".section .text.lock,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:\\\\tlock ; btrl $31,%0\\\\n\\" \\"4:\\\\tcmp $0,%0\\\\n\\\\t\\" \\"jne 4b\\\\n\\\\t\\" \\"jmp 1b\\\\n\\" \\".previous\\" :\\"=m\\" ( &__dummy_lock(&($rw)-> &lock)))";
	}' unless defined(&write_lock);
	eval 'sub write_unlock {
	    local($rw) = @_;
	    eval " &asm  &volatile(\\"lock ; btrl $31,%0\\":\\"=m\\" ( &__dummy_lock(&($rw)-> &lock)))";
	}' unless defined(&write_unlock);
	eval 'sub read_lock_irq {
	    local($lock) = @_;
	    eval " &do {  &__cli();  &read_lock($lock); }  &while (0)";
	}' unless defined(&read_lock_irq);
	eval 'sub read_unlock_irq {
	    local($lock) = @_;
	    eval " &do {  &read_unlock($lock);  &__sti(); }  &while (0)";
	}' unless defined(&read_unlock_irq);
	eval 'sub write_lock_irq {
	    local($lock) = @_;
	    eval " &do {  &__cli();  &write_lock($lock); }  &while (0)";
	}' unless defined(&write_lock_irq);
	eval 'sub write_unlock_irq {
	    local($lock) = @_;
	    eval " &do {  &write_unlock($lock);  &__sti(); }  &while (0)";
	}' unless defined(&write_unlock_irq);
	eval 'sub read_lock_irqsave {
	    local($lock, $flags) = @_;
	    eval " &do {  &__save_flags($flags);  &__cli();  &read_lock($lock); }  &while (0)";
	}' unless defined(&read_lock_irqsave);
	eval 'sub read_unlock_irqrestore {
	    local($lock, $flags) = @_;
	    eval " &do {  &read_unlock($lock);  &__restore_flags($flags); }  &while (0)";
	}' unless defined(&read_unlock_irqrestore);
	eval 'sub write_lock_irqsave {
	    local($lock, $flags) = @_;
	    eval " &do {  &__save_flags($flags);  &__cli();  &write_lock($lock); }  &while (0)";
	}' unless defined(&write_lock_irqsave);
	eval 'sub write_unlock_irqrestore {
	    local($lock, $flags) = @_;
	    eval " &do {  &write_unlock($lock);  &__restore_flags($flags); }  &while (0)";
	}' unless defined(&write_unlock_irqrestore);
    }
}
1;
