if (!defined &__i386_UACCESS_H) {
    eval 'sub __i386_UACCESS_H () {1;}' unless defined(&__i386_UACCESS_H);
    require 'linux/sched.ph';
    require 'asm/segment.ph';
    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
    eval 'sub get_fs () {
        eval "( &current-> &tss. &segment)";
    }' unless defined(&get_fs);
    eval 'sub get_ds () {
        eval "( &KERNEL_DS)";
    }' unless defined(&get_ds);
    eval 'sub set_fs {
        local($x) = @_;
        eval "( &current-> &tss. &segment = $sizeof{$x} == $sizeof{\'unsigned long\'} ? ($x) :  &__bad_fs_size())";
    }' unless defined(&set_fs);
    eval 'sub __addr_ok {
        local($x) = @_;
        eval "(((($x)>>30)& &get_fs()) != 3)";
    }' unless defined(&__addr_ok);
    eval 'sub __user_ok {
        local($addr,$size) = @_;
        eval "(($size <= 0xC0000000 &UL) && ($addr <= 0xC0000000 &UL - $size))";
    }' unless defined(&__user_ok);
    eval 'sub __kernel_ok () {(!( &get_fs() & 3));}' unless defined(&__kernel_ok);
    if ((defined(&CPU) ? &CPU : 0) > 386) {
	eval 'sub __access_ok {
	    local($type,$addr,$size) = @_;
	    eval "( &__kernel_ok ||  &__user_ok($addr,$size))";
	}' unless defined(&__access_ok);
    }
    else {
	eval 'sub __access_ok {
	    local($type,$addr,$size) = @_;
	    eval "( &__kernel_ok || ( &__user_ok($addr,$size) && (($type) ==  &VERIFY_READ ||  &wp_works_ok ||  &__verify_write(( &void *)($addr),($size)))))";
	}' unless defined(&__access_ok);
    }
    eval 'sub access_ok {
        local($type,$addr,$size) = @_;
        eval " &__access_ok(($type),($addr),($size))";
    }' unless defined(&access_ok);
    eval 'sub get_user {
        local($x,$ptr) = @_;
        eval " &__get_user_check(($x),($ptr),$sizeof{($ptr)})";
    }' unless defined(&get_user);
    eval 'sub put_user {
        local($x,$ptr) = @_;
        eval " &__put_user_check(( &__typeof__(*($ptr)))($x),($ptr),$sizeof{($ptr)})";
    }' unless defined(&put_user);
    eval 'sub __get_user {
        local($x,$ptr) = @_;
        eval " &__get_user_nocheck(($x),($ptr),$sizeof{($ptr)})";
    }' unless defined(&__get_user);
    eval 'sub __put_user {
        local($x,$ptr) = @_;
        eval " &__put_user_nocheck(( &__typeof__(*($ptr)))($x),($ptr),$sizeof{($ptr)})";
    }' unless defined(&__put_user);
    eval 'sub put_user_ret {
        local($x,$ptr,$ret) = @_;
        eval "({  &if ( &put_user($x,$ptr))  &return $ret; })";
    }' unless defined(&put_user_ret);
    eval 'sub get_user_ret {
        local($x,$ptr,$ret) = @_;
        eval "({  &if ( &get_user($x,$ptr))  &return $ret; })";
    }' unless defined(&get_user_ret);
    eval 'sub __put_user_ret {
        local($x,$ptr,$ret) = @_;
        eval "({  &if ( &__put_user($x,$ptr))  &return $ret; })";
    }' unless defined(&__put_user_ret);
    eval 'sub __get_user_ret {
        local($x,$ptr,$ret) = @_;
        eval "({  &if ( &__get_user($x,$ptr))  &return $ret; })";
    }' unless defined(&__get_user_ret);
    eval 'sub __put_user_nocheck {
        local($x,$ptr,$size) = @_;
        eval "({ \'long __pu_err\';  &__put_user_size(($x),($ptr),($size), &__pu_err);  &__pu_err; })";
    }' unless defined(&__put_user_nocheck);
    eval 'sub __put_user_check {
        local($x,$ptr,$size) = @_;
        eval "({ \'long __pu_err\' = - &EFAULT;  &__typeof__(*($ptr)) * &__pu_addr = ($ptr);  &if ( &access_ok( &VERIFY_WRITE, &__pu_addr,$size))  &__put_user_size(($x), &__pu_addr,($size), &__pu_err);  &__pu_err; })";
    }' unless defined(&__put_user_check);
    eval 'sub __put_user_size {
        local($x,$ptr,$size,$retval) = @_;
        eval " &do { $retval = 0;  &switch ($size) {  &case 1:  &__put_user_asm($x,$ptr,$retval,\\"b\\",\\"b\\",\\"iq\\");  &break;  &case 2:  &__put_user_asm($x,$ptr,$retval,\\"w\\",\\"w\\",\\"ir\\");  &break;  &case 4:  &__put_user_asm($x,$ptr,$retval,\\"l\\",\\"\\",\\"ir\\");  &break;  &default:  &__put_user_bad(); } }  &while (0)";
    }' unless defined(&__put_user_size);
    eval 'sub __m {
        local($x) = @_;
        eval "(*($x))";
    }' unless defined(&__m);
    eval 'sub __put_user_asm {
        local($x, $addr, $err, $itype, $rtype, $ltype) = @_;
        eval " &__asm__  &__volatile__( \\"1:	mov\\"$itype\\" %\\"$rtype\\"1,%2\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:	movl %3,%0\\\\n\\" \\"	jmp 2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align 4\\\\n\\" \\"	.long 1b,3b\\\\n\\" \\".previous\\" : \\"=r\\"($err) : $ltype ($x), \\"m\\"( &__m($addr)), \\"i\\"(- &EFAULT), \\"0\\"($err))";
    }' unless defined(&__put_user_asm);
    eval 'sub __get_user_nocheck {
        local($x,$ptr,$size) = @_;
        eval "({ \'long __gu_err\',  &__gu_val;  &__get_user_size( &__gu_val,($ptr),($size), &__gu_err); ($x) = ( &__typeof__(*($ptr))) &__gu_val;  &__gu_err; })";
    }' unless defined(&__get_user_nocheck);
    eval 'sub __get_user_check {
        local($x,$ptr,$size) = @_;
        eval "({ \'long __gu_err\' = - &EFAULT,  &__gu_val = 0;  &const  &__typeof__(*($ptr)) * &__gu_addr = ($ptr);  &if ( &access_ok( &VERIFY_READ, &__gu_addr,$size))  &__get_user_size( &__gu_val, &__gu_addr,($size), &__gu_err); ($x) = ( &__typeof__(*($ptr))) &__gu_val;  &__gu_err; })";
    }' unless defined(&__get_user_check);
    eval 'sub __get_user_size {
        local($x,$ptr,$size,$retval) = @_;
        eval " &do { $retval = 0;  &switch ($size) {  &case 1:  &__get_user_asm($x,$ptr,$retval,\\"b\\",\\"b\\",\\"=q\\");  &break;  &case 2:  &__get_user_asm($x,$ptr,$retval,\\"w\\",\\"w\\",\\"=r\\");  &break;  &case 4:  &__get_user_asm($x,$ptr,$retval,\\"l\\",\\"\\",\\"=r\\");  &break;  &default: ($x) =  &__get_user_bad(); } }  &while (0)";
    }' unless defined(&__get_user_size);
    eval 'sub __get_user_asm {
        local($x, $addr, $err, $itype, $rtype, $ltype) = @_;
        eval " &__asm__  &__volatile__( \\"1:	mov\\"$itype\\" %2,%\\"$rtype\\"1\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:	movl %3,%0\\\\n\\" \\"	xor\\"$itype\\" %\\"$rtype\\"1,%\\"$rtype\\"1\\\\n\\" \\"	jmp 2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align 4\\\\n\\" \\"	.long 1b,3b\\\\n\\" \\".previous\\" : \\"=r\\"($err), $ltype ($x) : \\"m\\"( &__m($addr)), \\"i\\"(- &EFAULT), \\"0\\"($err))";
    }' unless defined(&__get_user_asm);
    eval 'sub __copy_user {
        local($to,$from,$size) = @_;
        eval " &__asm__  &__volatile__( \\"0:	rep; movsl\\\\n\\" \\"	movl %1,%0\\\\n\\" \\"1:	rep; movsb\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:	lea 0(%1,%0,4),%0\\\\n\\" \\"	jmp 2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align 4\\\\n\\" \\"	.long 0b,3b\\\\n\\" \\"	.long 1b,2b\\\\n\\" \\".previous\\" : \\"=c\\"($size) : \\"r\\"($size & 3), \\"0\\"($size / 4), \\"D\\"($to), \\"S\\"($from) : \\"di\\", \\"si\\", \\"memory\\")";
    }' unless defined(&__copy_user);
    eval 'sub __constant_copy_user {
        local($to, $from, $size) = @_;
        eval " &do {  &switch ($size & 3) {  &default:  &__asm__  &__volatile__( \\"0:	rep; movsl\\\\n\\" \\"1:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"2:	shl $2,%0\\\\n\\" \\"	jmp 1b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align 4\\\\n\\" \\"	.long 0b,2b\\\\n\\" \\".previous\\" : \\"=c\\"($size) : \\"S\\"($from), \\"D\\"($to), \\"0\\"($size/4) : \\"di\\", \\"si\\", \\"memory\\");  &break;  &case 1:  &__asm__  &__volatile__( \\"0:	rep; movsl\\\\n\\" \\"1:	movsb\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:	shl $2,%0\\\\n\\" \\"4:	incl %0\\\\n\\" \\"	jmp 2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align 4\\\\n\\" \\"	.long 0b,3b\\\\n\\" \\"	.long 1b,4b\\\\n\\" \\".previous\\" : \\"=c\\"($size) : \\"S\\"($from), \\"D\\"($to), \\"0\\"($size/4) : \\"di\\", \\"si\\", \\"memory\\");  &break;  &case 2:  &__asm__  &__volatile__( \\"0:	rep; movsl\\\\n\\" \\"1:	movsw\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:	shl $2,%0\\\\n\\" \\"4:	addl $2,%0\\\\n\\" \\"	jmp 2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align 4\\\\n\\" \\"	.long 0b,3b\\\\n\\" \\"	.long 1b,4b\\\\n\\" \\".previous\\" : \\"=c\\"($size) : \\"S\\"($from), \\"D\\"($to), \\"0\\"($size/4) : \\"di\\", \\"si\\", \\"memory\\");  &break;  &case 3:  &__asm__  &__volatile__( \\"0:	rep; movsl\\\\n\\" \\"1:	movsw\\\\n\\" \\"2:	movsb\\\\n\\" \\"3:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"4:	shl $2,%0\\\\n\\" \\"5:	addl $2,%0\\\\n\\" \\"6:	incl %0\\\\n\\" \\"	jmp 3b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align 4\\\\n\\" \\"	.long 0b,4b\\\\n\\" \\"	.long 1b,5b\\\\n\\" \\"	.long 2b,6b\\\\n\\" \\".previous\\" : \\"=c\\"($size) : \\"S\\"($from), \\"D\\"($to), \\"0\\"($size/4) : \\"di\\", \\"si\\", \\"memory\\");  &break; } }  &while (0)";
    }' unless defined(&__constant_copy_user);
    eval 'sub copy_to_user {
        local($to,$from,$n) = @_;
        eval "( &__builtin_constant_p($n) ?  &__constant_copy_to_user(($to),($from),($n)) :  &__generic_copy_to_user(($to),($from),($n)))";
    }' unless defined(&copy_to_user);
    eval 'sub copy_from_user {
        local($to,$from,$n) = @_;
        eval "( &__builtin_constant_p($n) ?  &__constant_copy_from_user(($to),($from),($n)) :  &__generic_copy_from_user(($to),($from),($n)))";
    }' unless defined(&copy_from_user);
    eval 'sub copy_to_user_ret {
        local($to,$from,$n,$retval) = @_;
        eval "({  &if ( &copy_to_user($to,$from,$n))  &return $retval; })";
    }' unless defined(&copy_to_user_ret);
    eval 'sub copy_from_user_ret {
        local($to,$from,$n,$retval) = @_;
        eval "({  &if ( &copy_from_user($to,$from,$n))  &return $retval; })";
    }' unless defined(&copy_from_user_ret);
    eval 'sub __copy_to_user {
        local($to,$from,$n) = @_;
        eval "( &__builtin_constant_p($n) ?  &__constant_copy_to_user_nocheck(($to),($from),($n)) :  &__generic_copy_to_user_nocheck(($to),($from),($n)))";
    }' unless defined(&__copy_to_user);
    eval 'sub __copy_from_user {
        local($to,$from,$n) = @_;
        eval "( &__builtin_constant_p($n) ?  &__constant_copy_from_user_nocheck(($to),($from),($n)) :  &__generic_copy_from_user_nocheck(($to),($from),($n)))";
    }' unless defined(&__copy_from_user);
    eval 'sub __do_clear_user {
        local($addr,$size) = @_;
        eval " &__asm__  &__volatile__( \\"0:	rep; stosl\\\\n\\" \\"	movl %1,%0\\\\n\\" \\"1:	rep; stosb\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:	lea 0(%1,%0,4),%0\\\\n\\" \\"	jmp 2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align 4\\\\n\\" \\"	.long 0b,3b\\\\n\\" \\"	.long 1b,2b\\\\n\\" \\".previous\\" : \\"=c\\"($size) : \\"r\\"($size & 3), \\"0\\"($size / 4), \\"D\\"($addr), \\"a\\"(0) : \\"di\\")";
    }' unless defined(&__do_clear_user);
    eval 'sub __do_strncpy_from_user {
        local($dst,$src,$count,$res) = @_;
        eval " &__asm__  &__volatile__( \\"	testl %1,%1\\\\n\\" \\"	jz 2f\\\\n\\" \\"0:	lodsb\\\\n\\" \\"	stosb\\\\n\\" \\"	testb %%al,%%al\\\\n\\" \\"	jz 1f\\\\n\\" \\"	decl %1\\\\n\\" \\"	jnz 0b\\\\n\\" \\"1:	subl %1,%0\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:	movl %2,%0\\\\n\\" \\"	jmp 2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align 4\\\\n\\" \\"	.long 0b,3b\\\\n\\" \\".previous\\" : \\"=d\\"($res), \\"=c\\"($count) : \\"i\\"(- &EFAULT), \\"0\\"($count), \\"1\\"($count), \\"S\\"($src), \\"D\\"($dst) : \\"si\\", \\"di\\", \\"ax\\", \\"memory\\")";
    }' unless defined(&__do_strncpy_from_user);
}
1;
