if (!defined &_LINUX_NCP_FS_H) {
    eval 'sub _LINUX_NCP_FS_H () {1;}' unless defined(&_LINUX_NCP_FS_H);
    require 'linux/fs.ph';
    require 'linux/in.ph';
    require 'linux/types.ph';
    require 'linux/ncp_mount.ph';
    require 'linux/ncp_fs_sb.ph';
    require 'linux/ncp_fs_i.ph';
    eval 'sub NCP_IOC_NCPREQUEST () { &_IOR(ord(\'n\'), 1, \'struct ncp_ioctl_request\');}' unless defined(&NCP_IOC_NCPREQUEST);
    eval 'sub NCP_IOC_GETMOUNTUID () { &_IOW(ord(\'n\'), 2,  &uid_t);}' unless defined(&NCP_IOC_GETMOUNTUID);
    eval 'sub NCP_IOC_CONN_LOGGED_IN () { &_IO(ord(\'n\'), 3);}' unless defined(&NCP_IOC_CONN_LOGGED_IN);
    eval 'sub NCP_GET_FS_INFO_VERSION () {(1);}' unless defined(&NCP_GET_FS_INFO_VERSION);
    eval 'sub NCP_IOC_GET_FS_INFO () { &_IOWR(ord(\'n\'), 4, \'struct ncp_fs_info\');}' unless defined(&NCP_IOC_GET_FS_INFO);
    eval 'sub NCP_PACKET_SIZE () {4070;}' unless defined(&NCP_PACKET_SIZE);
    eval 'sub NCP_MAXPATHLEN () {255;}' unless defined(&NCP_MAXPATHLEN);
    eval 'sub NCP_MAXNAMELEN () {14;}' unless defined(&NCP_MAXNAMELEN);
    if (defined &__KERNEL__) {
	eval 'sub NCP_READDIR_CACHE_SIZE () {64;}' unless defined(&NCP_READDIR_CACHE_SIZE);
	eval 'sub NCP_MAX_RPC_TIMEOUT () {(6* &HZ);}' unless defined(&NCP_MAX_RPC_TIMEOUT);
	eval 'sub NCP_SUPER_MAGIC () {0x564c;}' unless defined(&NCP_SUPER_MAGIC);
	eval 'sub NCP_SBP {
	    local($sb) = @_;
	    eval "((($sb)-> &u. &generic_sbp))";
	}' unless defined(&NCP_SBP);
	eval 'sub NCP_INOP {
	    local($inode) = @_;
	    eval "((($inode)-> &u. &generic_ip))";
	}' unless defined(&NCP_INOP);
	eval 'sub NCP_SERVER {
	    local($inode) = @_;
	    eval " &NCP_SBP(($inode)-> &i_sb)";
	}' unless defined(&NCP_SERVER);
	eval 'sub NCP_FINFO {
	    local($inode) = @_;
	    eval "(&( &NCP_INOP($inode)-> &finfo))";
	}' unless defined(&NCP_FINFO);
	eval 'sub NCP_ISTRUCT {
	    local($inode) = @_;
	    eval "(&( &NCP_FINFO($inode)-> &i))";
	}' unless defined(&NCP_ISTRUCT);
	if (defined &DEBUG_NCP_MALLOC) {
	    require 'linux/malloc.ph';
	}
	else {
	    eval 'sub ncp_kmalloc {
	        local($s,$p) = @_;
	        eval " &kmalloc($s,$p)";
	    }' unless defined(&ncp_kmalloc);
	    eval 'sub ncp_kfree_s {
	        local($o,$s) = @_;
	        eval " &kfree_s($o,$s)";
	    }' unless defined(&ncp_kfree_s);
	}
	if ((defined(&DEBUG_NCP) ? &DEBUG_NCP : 0) > 0) {
	    eval 'sub DPRINTK () {( &format,  &args...)  &printk( &format ,   &args);}' unless defined(&DPRINTK);
	}
	else {
	    eval 'sub DPRINTK () {( &format,  &args...);}' unless defined(&DPRINTK);
	}
	if ((defined(&DEBUG_NCP) ? &DEBUG_NCP : 0) > 1) {
	    eval 'sub DDPRINTK () {( &format,  &args...)  &printk( &format ,   &args);}' unless defined(&DDPRINTK);
	}
	else {
	    eval 'sub DDPRINTK () {( &format,  &args...);}' unless defined(&DDPRINTK);
	}
    }
}
1;
