if (!defined &_LINUX_SCHED_H) {
    eval 'sub _LINUX_SCHED_H () {1;}' unless defined(&_LINUX_SCHED_H);
    require 'asm/param.ph';
    require 'linux/binfmts.ph';
    require 'linux/personality.ph';
    require 'linux/tasks.ph';
    require 'linux/kernel.ph';
    require 'linux/types.ph';
    require 'linux/times.ph';
    require 'asm/system.ph';
    require 'asm/semaphore.ph';
    require 'asm/page.ph';
    require 'linux/smp.ph';
    require 'linux/tty.ph';
    require 'linux/sem.ph';
    eval 'sub CSIGNAL () {0x000000ff;}' unless defined(&CSIGNAL);
    eval 'sub CLONE_VM () {0x00000100;}' unless defined(&CLONE_VM);
    eval 'sub CLONE_FS () {0x00000200;}' unless defined(&CLONE_FS);
    eval 'sub CLONE_FILES () {0x00000400;}' unless defined(&CLONE_FILES);
    eval 'sub CLONE_SIGHAND () {0x00000800;}' unless defined(&CLONE_SIGHAND);
    eval 'sub CLONE_PID () {0x00001000;}' unless defined(&CLONE_PID);
    eval 'sub FSHIFT () {11;}' unless defined(&FSHIFT);
    eval 'sub FIXED_1 () {(1<< &FSHIFT);}' unless defined(&FIXED_1);
    eval 'sub LOAD_FREQ () {(5* &HZ);}' unless defined(&LOAD_FREQ);
    eval 'sub EXP_1 () {1884;}' unless defined(&EXP_1);
    eval 'sub EXP_5 () {2014;}' unless defined(&EXP_5);
    eval 'sub EXP_15 () {2037;}' unless defined(&EXP_15);
    eval 'sub CALC_LOAD {
        local($load,$exp,$n) = @_;
        eval "$load *= $exp; $load += $n*( &FIXED_1-$exp); $load >>=  &FSHIFT;";
    }' unless defined(&CALC_LOAD);
    eval 'sub CT_TO_SECS {
        local($x) = @_;
        eval "(($x) /  &HZ)";
    }' unless defined(&CT_TO_SECS);
    eval 'sub CT_TO_USECS {
        local($x) = @_;
        eval "((($x) %  &HZ) * 1000000/ &HZ)";
    }' unless defined(&CT_TO_USECS);
    require 'linux/head.ph';
    require 'linux/fs.ph';
    require 'linux/signal.ph';
    require 'linux/time.ph';
    require 'linux/param.ph';
    require 'linux/resource.ph';
    require 'linux/ptrace.ph';
    require 'linux/timer.ph';
    require 'asm/processor.ph';
    eval 'sub TASK_RUNNING () {0;}' unless defined(&TASK_RUNNING);
    eval 'sub TASK_INTERRUPTIBLE () {1;}' unless defined(&TASK_INTERRUPTIBLE);
    eval 'sub TASK_UNINTERRUPTIBLE () {2;}' unless defined(&TASK_UNINTERRUPTIBLE);
    eval 'sub TASK_ZOMBIE () {3;}' unless defined(&TASK_ZOMBIE);
    eval 'sub TASK_STOPPED () {4;}' unless defined(&TASK_STOPPED);
    eval 'sub TASK_SWAPPING () {5;}' unless defined(&TASK_SWAPPING);
    eval 'sub SCHED_OTHER () {0;}' unless defined(&SCHED_OTHER);
    eval 'sub SCHED_FIFO () {1;}' unless defined(&SCHED_FIFO);
    eval 'sub SCHED_RR () {2;}' unless defined(&SCHED_RR);
    if (!defined &NULL) {
	eval 'sub NULL () {(( &void *) 0);}' unless defined(&NULL);
    }
    if (defined &__KERNEL__) {
	require 'asm/spinlock.ph';
	eval 'sub INIT_FILES () {{ 1, { { 0, } }, { { 0, } }, {  &NULL, } };}' unless defined(&INIT_FILES);
	eval 'sub INIT_FS () {{ 1, 0022,  &NULL,  &NULL };}' unless defined(&INIT_FS);
	eval 'sub INIT_MM () {{ & &init_mmap,  &NULL,  &swapper_pg_dir, 1,  &MUTEX, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };}' unless defined(&INIT_MM);
	eval 'sub INIT_SIGNALS () {{  &ATOMIC_INIT(1), { {0,}, },  &SPIN_LOCK_UNLOCKED };}' unless defined(&INIT_SIGNALS);
	eval 'sub PF_ALIGNWARN () {0x00000001;}' unless defined(&PF_ALIGNWARN);
	eval 'sub PF_PTRACED () {0x00000010;}' unless defined(&PF_PTRACED);
	eval 'sub PF_TRACESYS () {0x00000020;}' unless defined(&PF_TRACESYS);
	eval 'sub PF_FORKNOEXEC () {0x00000040;}' unless defined(&PF_FORKNOEXEC);
	eval 'sub PF_SUPERPRIV () {0x00000100;}' unless defined(&PF_SUPERPRIV);
	eval 'sub PF_DUMPCORE () {0x00000200;}' unless defined(&PF_DUMPCORE);
	eval 'sub PF_SIGNALED () {0x00000400;}' unless defined(&PF_SIGNALED);
	eval 'sub PF_STARTING () {0x00000002;}' unless defined(&PF_STARTING);
	eval 'sub PF_EXITING () {0x00000004;}' unless defined(&PF_EXITING);
	eval 'sub PF_USEDFPU () {0x00100000;}' unless defined(&PF_USEDFPU);
	eval 'sub PF_DTRACE () {0x00200000;}' unless defined(&PF_DTRACE);
	eval 'sub PF_ONSIGSTK () {0x00400000;}' unless defined(&PF_ONSIGSTK);
	eval 'sub _STK_LIM () {(8*1024*1024);}' unless defined(&_STK_LIM);
	eval 'sub DEF_PRIORITY () {(20* &HZ/100);}' unless defined(&DEF_PRIORITY);
	if (defined &__SMP__) {
	    eval 'sub INIT_LOCKS () { &SPIN_LOCK_UNLOCKED;}' unless defined(&INIT_LOCKS);
	}
	else {
	    eval 'sub INIT_LOCKS () {1;}' unless defined(&INIT_LOCKS);
	}
	eval 'sub INIT_TASK () {{ 0, &DEF_PRIORITY, &DEF_PRIORITY,0,0,0,0, { 0, }, & &default_exec_domain,  &NULL, & &init_task,& &init_task, & &init_task, & &init_task, 0,0,0,0,0, 0,0,0,0,0, 0, {0,}, & &init_task,& &init_task, &NULL, &NULL, &NULL,  &NULL,  &NULL, & $task[0],  &NULL, 0,0,0,0,0,0,0,0, 0, &SCHED_OTHER,0,0,0,0,0,0,0, {  &NULL,  &NULL, 0, 0,  &it_real_fn }, {0,0,0,0},0, 0,0,0,0,0,0, 0,0,0,0,0,  &INIT_RLIMITS, 0, "swapper", 0, &NULL,  &NULL,  &NULL,  &NULL,  &INIT_TSS, & &init_fs, & &init_files, & &init_mm, & &init_signals, 0,0,0,0,  &INIT_LOCKS };}' unless defined(&INIT_TASK);
	eval 'sub PIDHASH_SZ () {( &NR_TASKS >> 2);}' unless defined(&PIDHASH_SZ);
	eval 'sub pid_hashfn {
	    local($x) = @_;
	    eval "(((($x) >> 8) ^ ($x)) & ( &PIDHASH_SZ - 1))";
	}' unless defined(&pid_hashfn);
	require 'asm/current.ph';
	eval 'sub CURRENT_TIME () {( &xtime. &tv_sec);}' unless defined(&CURRENT_TIME);
	eval 'sub REMOVE_LINKS {
	    local($p) = @_;
	    eval " &do { \'unsigned long\'  &flags;  &write_lock_irqsave(& &tasklist_lock,  &flags); ($p)-> &next_task-> &prev_task = ($p)-> &prev_task; ($p)-> &prev_task-> &next_task = ($p)-> &next_task;  &write_unlock_irqrestore(& &tasklist_lock,  &flags);  &if (($p)-> &p_osptr) ($p)-> &p_osptr-> &p_ysptr = ($p)-> &p_ysptr;  &if (($p)-> &p_ysptr) ($p)-> &p_ysptr-> &p_osptr = ($p)-> &p_osptr;  &else ($p)-> &p_pptr-> &p_cptr = ($p)-> &p_osptr; }  &while (0)";
	}' unless defined(&REMOVE_LINKS);
	eval 'sub SET_LINKS {
	    local($p) = @_;
	    eval " &do { \'unsigned long\'  &flags;  &write_lock_irqsave(& &tasklist_lock,  &flags); ($p)-> &next_task = & &init_task; ($p)-> &prev_task =  &init_task. &prev_task;  &init_task. &prev_task-> &next_task = ($p);  &init_task. &prev_task = ($p);  &write_unlock_irqrestore(& &tasklist_lock,  &flags); ($p)-> &p_ysptr =  &NULL;  &if ((($p)-> &p_osptr = ($p)-> &p_pptr-> &p_cptr) !=  &NULL) ($p)-> &p_osptr-> &p_ysptr = $p; ($p)-> &p_pptr-> &p_cptr = $p; }  &while (0)";
	}' unless defined(&SET_LINKS);
	eval 'sub for_each_task {
	    local($p) = @_;
	    eval " &for ($p = & &init_task ; ($p = $p-> &next_task) != & &init_task ; )";
	}' unless defined(&for_each_task);
    }
}
1;
