if (!defined &__LINUX_UFS_FS_H) {
    eval 'sub __LINUX_UFS_FS_H () {1;}' unless defined(&__LINUX_UFS_FS_H);
    require 'linux/types.ph';
    require 'linux/kernel.ph';
    require 'linux/time.ph';
    require 'linux/stat.ph';
    eval 'sub UFS_BBLOCK () {0;}' unless defined(&UFS_BBLOCK);
    eval 'sub UFS_BBSIZE () {8192;}' unless defined(&UFS_BBSIZE);
    eval 'sub UFS_SBLOCK () {8192;}' unless defined(&UFS_SBLOCK);
    eval 'sub UFS_SBSIZE () {8192;}' unless defined(&UFS_SBSIZE);
    eval 'sub UFS_MAGIC () {0x00011954;}' unless defined(&UFS_MAGIC);
    eval 'sub UFS_FSIZE () {1024;}' unless defined(&UFS_FSIZE);
    eval 'sub UFS_BSIZE () {8192;}' unless defined(&UFS_BSIZE);
    eval 'sub UFS_NDADDR () {12;}' unless defined(&UFS_NDADDR);
    eval 'sub UFS_NINDIR () {3;}' unless defined(&UFS_NINDIR);
    eval 'sub UFS_IND_BLOCK () {( &UFS_NDADDR + 0);}' unless defined(&UFS_IND_BLOCK);
    eval 'sub UFS_DIND_BLOCK () {( &UFS_NDADDR + 1);}' unless defined(&UFS_DIND_BLOCK);
    eval 'sub UFS_TIND_BLOCK () {( &UFS_NDADDR + 2);}' unless defined(&UFS_TIND_BLOCK);
    eval 'sub UFS_ROOTINO () {2;}' unless defined(&UFS_ROOTINO);
    eval 'sub UFS_USEEFT () {(( &__u16)65535);}' unless defined(&UFS_USEEFT);
    eval 'sub UFS_FSOK () {0x7c269d38;}' unless defined(&UFS_FSOK);
    eval 'sub UFS_FSACTIVE () {(0x00);}' unless defined(&UFS_FSACTIVE);
    eval 'sub UFS_FSCLEAN () {(0x01);}' unless defined(&UFS_FSCLEAN);
    eval 'sub UFS_FSSTABLE () {(0x02);}' unless defined(&UFS_FSSTABLE);
    eval 'sub UFS_FSBAD () {(0xff);}' unless defined(&UFS_FSBAD);
    eval 'sub UFS_DEBUG () {0x00000001;}' unless defined(&UFS_DEBUG);
    eval 'sub UFS_DEBUG_INODE () {0x00000002;}' unless defined(&UFS_DEBUG_INODE);
    eval 'sub UFS_DEBUG_NAMEI () {0x00000004;}' unless defined(&UFS_DEBUG_NAMEI);
    eval 'sub UFS_DEBUG_LINKS () {0x00000008;}' unless defined(&UFS_DEBUG_LINKS);
    eval 'sub UFS_ADDR_PER_BLOCK {
        local($sb) = @_;
        eval "(($sb)-> &u. &ufs_sb. &s_bsize >> 2)";
    }' unless defined(&UFS_ADDR_PER_BLOCK);
    eval 'sub UFS_ADDR_PER_BLOCK_BITS {
        local($sb) = @_;
        eval "(($sb)-> &u. &ufs_sb. &s_bshift - 2)";
    }' unless defined(&UFS_ADDR_PER_BLOCK_BITS);
    eval 'sub ufs_ino_ok {
        local($inode) = @_;
        eval "(($inode-> &i_ino < 2) && ($inode-> &i_ino > ($inode-> &i_sb-> &u. &ufs_sb. &s_ncg * $inode-> &i_sb-> &u. &ufs_sb. &s_ipg - 1)))";
    }' unless defined(&ufs_ino_ok);
    eval 'sub ufs_cgstart {
        local($sb, $cg) = @_;
        eval "((($sb)-> &u. &ufs_sb. &s_fpg * ($cg)) + ($sb)-> &u. &ufs_sb. &s_cgoffset * (($cg) & ~(($sb)-> &u. &ufs_sb. &s_cgmask)))";
    }' unless defined(&ufs_cgstart);
    eval 'sub ufs_cgimin {
        local($sb, $cg) = @_;
        eval "( &ufs_cgstart(($sb), ($cg)) + ($sb)-> &u. &ufs_sb. &s_iblkno)";
    }' unless defined(&ufs_cgimin);
    eval 'sub ufs_cgdmin {
        local($sb, $cg) = @_;
        eval "( &ufs_cgstart(($sb), ($cg)) + ($sb)-> &u. &ufs_sb. &s_dblkno)";
    }' unless defined(&ufs_cgdmin);
    eval 'sub ufs_ino2cg {
        local($inode) = @_;
        eval "(($inode)-> &i_ino/($inode)-> &i_sb-> &u. &ufs_sb. &s_ipg)";
    }' unless defined(&ufs_ino2cg);
    eval 'sub UFS_MAXNAMLEN () {255;}' unless defined(&UFS_MAXNAMLEN);
    eval 'sub ufs_lbn {
        local($sb, $block) = @_;
        eval "(($block) >> ($sb)-> &u. &ufs_sb. &s_lshift)";
    }' unless defined(&ufs_lbn);
    eval 'sub ufs_boff {
        local($sb, $block) = @_;
        eval "(($block) & ~(($sb)-> &u. &ufs_sb. &s_lmask))";
    }' unless defined(&ufs_boff);
    eval 'sub ufs_dbn {
        local($sb, $block, $boff) = @_;
        eval "(($block) +  &ufs_boff(($sb), ($boff)))";
    }' unless defined(&ufs_dbn);
    eval 'sub MAXMNTLEN () {512;}' unless defined(&MAXMNTLEN);
    eval 'sub MAXCSBUFS () {32;}' unless defined(&MAXCSBUFS);
    if (defined &__KERNEL__) {
    }
}
1;
