if (!defined &_TCL) {
    eval 'sub _TCL () {1;}' unless defined(&_TCL);
    eval 'sub TCL_MAJOR_VERSION () {7;}' unless defined(&TCL_MAJOR_VERSION);
    eval 'sub TCL_MINOR_VERSION () {6;}' unless defined(&TCL_MINOR_VERSION);
    eval 'sub TCL_RELEASE_LEVEL () {2;}' unless defined(&TCL_RELEASE_LEVEL);
    eval 'sub TCL_RELEASE_SERIAL () {0;}' unless defined(&TCL_RELEASE_SERIAL);
    eval 'sub TCL_VERSION () {"7.6";}' unless defined(&TCL_VERSION);
    eval 'sub TCL_PATCH_LEVEL () {"7.6";}' unless defined(&TCL_PATCH_LEVEL);
    if (!defined &__WIN32__) {
	if (defined( &_WIN32) || defined( &WIN32)) {
	    eval 'sub __WIN32__ () {1;}' unless defined(&__WIN32__);
	}
    }
    if (defined &__WIN32__) {
	if (!defined &STRICT) {
	    eval 'sub STRICT () {1;}' unless defined(&STRICT);
	}
	if (!defined &USE_PROTOTYPE) {
	    eval 'sub USE_PROTOTYPE () {1;}' unless defined(&USE_PROTOTYPE);
	}
	if (!defined &HAS_STDARG) {
	    eval 'sub HAS_STDARG () {1;}' unless defined(&HAS_STDARG);
	}
	if (!defined &USE_PROTOTYPE) {
	    eval 'sub USE_PROTOTYPE () {1;}' unless defined(&USE_PROTOTYPE);
	}
	if (!defined &USE_TCLALLOC) {
	    eval 'sub USE_TCLALLOC () {1;}' unless defined(&USE_TCLALLOC);
	}
	if (!defined &STRINGIFY) {
	    eval 'sub STRINGIFY {
	        local($x) = @_;
	        eval " &STRINGIFY1($x)";
	    }' unless defined(&STRINGIFY);
	    eval 'sub STRINGIFY1 {
	        local($x) = @_;
	        eval "$x";
	    }' unless defined(&STRINGIFY1);
	}
    }
    if (defined &MAC_TCL) {
	if (!defined &HAS_STDARG) {
	    eval 'sub HAS_STDARG () {1;}' unless defined(&HAS_STDARG);
	}
	if (!defined &USE_TCLALLOC) {
	    eval 'sub USE_TCLALLOC () {1;}' unless defined(&USE_TCLALLOC);
	}
	if (!defined &NO_STRERROR) {
	    eval 'sub NO_STRERROR () {1;}' unless defined(&NO_STRERROR);
	}
    }
    if (!defined &RESOURCE_INCLUDED) {
	if (!defined &BUFSIZ) {
	    require 'stdio.ph';
	}
	if (defined( &__STDC__) || defined( &HAS_STDARG)) {
	    eval 'sub TCL_VARARGS {
	        local($type, $name) = @_;
	        eval "($type $name, ...)";
	    }' unless defined(&TCL_VARARGS);
	    eval 'sub TCL_VARARGS_DEF {
	        local($type, $name) = @_;
	        eval "($type $name, ...)";
	    }' unless defined(&TCL_VARARGS_DEF);
	    eval 'sub TCL_VARARGS_START {
	        local($type, $name, $list) = @_;
	        eval "( &va_start($list, $name), $name)";
	    }' unless defined(&TCL_VARARGS_START);
	}
	else {
	    if (defined &__cplusplus) {
		eval 'sub TCL_VARARGS {
		    local($type, $name) = @_;
		    eval "($type $name, ...)";
		}' unless defined(&TCL_VARARGS);
		eval 'sub TCL_VARARGS_DEF {
		    local($type, $name) = @_;
		    eval "($type  &va_alist, ...)";
		}' unless defined(&TCL_VARARGS_DEF);
	    }
	    else {
		eval 'sub TCL_VARARGS {
		    local($type, $name) = @_;
		    eval "()";
		}' unless defined(&TCL_VARARGS);
		eval 'sub TCL_VARARGS_DEF {
		    local($type, $name) = @_;
		    eval "( &va_alist)";
		}' unless defined(&TCL_VARARGS_DEF);
	    }
	    eval 'sub TCL_VARARGS_START {
	        local($type, $name, $list) = @_;
	        eval "( &va_start($list),  &va_arg($list, $type))";
	    }' unless defined(&TCL_VARARGS_START);
	}
	if (((defined( &__STDC__) || defined( &SABER)) && !defined( &NO_PROTOTYPE)) || defined( &__cplusplus) || defined( &USE_PROTOTYPE)) {
	    eval 'sub _USING_PROTOTYPES_ () {1;}' unless defined(&_USING_PROTOTYPES_);
	    eval 'sub _ANSI_ARGS_ {
	        local($x) = @_;
	        eval "$x";
	    }' unless defined(&_ANSI_ARGS_);
	    eval 'sub CONST () { &const;}' unless defined(&CONST);
	}
	else {
	    eval 'sub _ANSI_ARGS_ {
	        local($x) = @_;
	        eval "()";
	    }' unless defined(&_ANSI_ARGS_);
	    eval 'sub CONST () {1;}' unless defined(&CONST);
	}
	if (defined &__cplusplus) {
	    eval 'sub EXTERN () { &extern "C";}' unless defined(&EXTERN);
	}
	else {
	    eval 'sub EXTERN () { &extern;}' unless defined(&EXTERN);
	}
	if (!defined &__WIN32__) {
	    if (!defined &VOID) {
		if (defined &__STDC__) {
		    eval 'sub VOID () { &void;}' unless defined(&VOID);
		}
		else {
		    eval 'sub VOID () {\'char\';}' unless defined(&VOID);
		}
	    }
	}
	else {
	    if (!defined &VOID) {
		eval 'sub VOID () { &void;}' unless defined(&VOID);
	    }
	}
	if (!defined &NULL) {
	    eval 'sub NULL () {0;}' unless defined(&NULL);
	}
	if (!defined &_CLIENTDATA) {
	    if (defined( &__STDC__) || defined( &__cplusplus)) {
	    }
	    else {
	    }
	    eval 'sub _CLIENTDATA () {1;}' unless defined(&_CLIENTDATA);
	}
	eval 'sub TCL_OK () {0;}' unless defined(&TCL_OK);
	eval 'sub TCL_ERROR () {1;}' unless defined(&TCL_ERROR);
	eval 'sub TCL_RETURN () {2;}' unless defined(&TCL_RETURN);
	eval 'sub TCL_BREAK () {3;}' unless defined(&TCL_BREAK);
	eval 'sub TCL_CONTINUE () {4;}' unless defined(&TCL_CONTINUE);
	eval 'sub TCL_RESULT_SIZE () {200;}' unless defined(&TCL_RESULT_SIZE);
	eval 'sub TCL_DSTRING_STATIC_SIZE () {200;}' unless defined(&TCL_DSTRING_STATIC_SIZE);
	eval 'sub Tcl_DStringLength {
	    local($dsPtr) = @_;
	    eval "(($dsPtr)-> &length)";
	}' unless defined(&Tcl_DStringLength);
	eval 'sub Tcl_DStringValue {
	    local($dsPtr) = @_;
	    eval "(($dsPtr)-> &string)";
	}' unless defined(&Tcl_DStringValue);
	eval 'sub Tcl_DStringTrunc () { &Tcl_DStringSetLength;}' unless defined(&Tcl_DStringTrunc);
	eval 'sub TCL_MAX_PREC () {17;}' unless defined(&TCL_MAX_PREC);
	eval 'sub TCL_DOUBLE_SPACE () {( &TCL_MAX_PREC+10);}' unless defined(&TCL_DOUBLE_SPACE);
	eval 'sub TCL_DONT_USE_BRACES () {1;}' unless defined(&TCL_DONT_USE_BRACES);
	eval 'sub TCL_NO_EVAL () {0x10000;}' unless defined(&TCL_NO_EVAL);
	eval 'sub TCL_EVAL_GLOBAL () {0x20000;}' unless defined(&TCL_EVAL_GLOBAL);
	eval 'sub TCL_VOLATILE () {(( &Tcl_FreeProc *) 1);}' unless defined(&TCL_VOLATILE);
	eval 'sub TCL_STATIC () {(( &Tcl_FreeProc *) 0);}' unless defined(&TCL_STATIC);
	eval 'sub TCL_DYNAMIC () {(( &Tcl_FreeProc *) 3);}' unless defined(&TCL_DYNAMIC);
	eval 'sub TCL_GLOBAL_ONLY () {1;}' unless defined(&TCL_GLOBAL_ONLY);
	eval 'sub TCL_APPEND_VALUE () {2;}' unless defined(&TCL_APPEND_VALUE);
	eval 'sub TCL_LIST_ELEMENT () {4;}' unless defined(&TCL_LIST_ELEMENT);
	eval 'sub TCL_TRACE_READS () {0x10;}' unless defined(&TCL_TRACE_READS);
	eval 'sub TCL_TRACE_WRITES () {0x20;}' unless defined(&TCL_TRACE_WRITES);
	eval 'sub TCL_TRACE_UNSETS () {0x40;}' unless defined(&TCL_TRACE_UNSETS);
	eval 'sub TCL_TRACE_DESTROYED () {0x80;}' unless defined(&TCL_TRACE_DESTROYED);
	eval 'sub TCL_INTERP_DESTROYED () {0x100;}' unless defined(&TCL_INTERP_DESTROYED);
	eval 'sub TCL_LEAVE_ERR_MSG () {0x200;}' unless defined(&TCL_LEAVE_ERR_MSG);
	eval 'sub TCL_LINK_INT () {1;}' unless defined(&TCL_LINK_INT);
	eval 'sub TCL_LINK_DOUBLE () {2;}' unless defined(&TCL_LINK_DOUBLE);
	eval 'sub TCL_LINK_BOOLEAN () {3;}' unless defined(&TCL_LINK_BOOLEAN);
	eval 'sub TCL_LINK_STRING () {4;}' unless defined(&TCL_LINK_STRING);
	eval 'sub TCL_LINK_READ_ONLY () {0x80;}' unless defined(&TCL_LINK_READ_ONLY);
	if (defined &TCL_MEM_DEBUG) {
	    eval 'sub Tcl_Alloc {
	        local($x) = @_;
	        eval " &Tcl_DbCkalloc($x,  &__FILE__,  &__LINE__)";
	    }' unless defined(&Tcl_Alloc);
	    eval 'sub Tcl_Free {
	        local($x) = @_;
	        eval " &Tcl_DbCkfree($x,  &__FILE__,  &__LINE__)";
	    }' unless defined(&Tcl_Free);
	    eval 'sub Tcl_Realloc {
	        local($x,$y) = @_;
	        eval " &Tcl_DbCkrealloc(($x), ($y), &__FILE__,  &__LINE__)";
	    }' unless defined(&Tcl_Realloc);
	    eval 'sub ckalloc {
	        local($x) = @_;
	        eval " &Tcl_DbCkalloc($x,  &__FILE__,  &__LINE__)";
	    }' unless defined(&ckalloc);
	    eval 'sub ckfree {
	        local($x) = @_;
	        eval " &Tcl_DbCkfree($x,  &__FILE__,  &__LINE__)";
	    }' unless defined(&ckfree);
	    eval 'sub ckrealloc {
	        local($x,$y) = @_;
	        eval " &Tcl_DbCkrealloc(($x), ($y), &__FILE__,  &__LINE__)";
	    }' unless defined(&ckrealloc);
	}
	else {
	    if ((defined(&USE_TCLALLOC) ? &USE_TCLALLOC : 0)) {
		eval 'sub ckalloc {
		    local($x) = @_;
		    eval " &Tcl_Alloc($x)";
		}' unless defined(&ckalloc);
		eval 'sub ckfree {
		    local($x) = @_;
		    eval " &Tcl_Free($x)";
		}' unless defined(&ckfree);
		eval 'sub ckrealloc {
		    local($x,$y) = @_;
		    eval " &Tcl_Realloc($x,$y)";
		}' unless defined(&ckrealloc);
	    }
	    else {
		eval 'sub ckalloc {
		    local($x) = @_;
		    eval " &malloc($x)";
		}' unless defined(&ckalloc);
		eval 'sub ckfree {
		    local($x) = @_;
		    eval " &free($x)";
		}' unless defined(&ckfree);
		eval 'sub ckrealloc {
		    local($x,$y) = @_;
		    eval " &realloc($x,$y)";
		}' unless defined(&ckrealloc);
	    }
	    eval 'sub Tcl_DumpActiveMemory {
	        local($x) = @_;
	        eval "";
	    }' unless defined(&Tcl_DumpActiveMemory);
	    eval 'sub Tcl_ValidateAllMemory {
	        local($x,$y) = @_;
	        eval "";
	    }' unless defined(&Tcl_ValidateAllMemory);
	}
	eval 'sub Tcl_FreeResult {
	    local($interp) = @_;
	    eval " &if (($interp)-> &freeProc != 0) {  &if ((($interp)-> &freeProc ==  &TCL_DYNAMIC) || (($interp)-> &freeProc == ( &Tcl_FreeProc *)  &free)) {  &ckfree(($interp)-> &result); }  &else { (*($interp)-> &freeProc)(($interp)-> &result); } ($interp)-> &freeProc = 0; }";
	}' unless defined(&Tcl_FreeResult);
	if (defined &__cplusplus) {
	}
	eval 'sub TCL_SMALL_HASH_TABLE () {4;}' unless defined(&TCL_SMALL_HASH_TABLE);
	eval 'sub TCL_STRING_KEYS () {0;}' unless defined(&TCL_STRING_KEYS);
	eval 'sub TCL_ONE_WORD_KEYS () {1;}' unless defined(&TCL_ONE_WORD_KEYS);
	eval 'sub Tcl_GetHashValue {
	    local($h) = @_;
	    eval "(($h)-> &clientData)";
	}' unless defined(&Tcl_GetHashValue);
	eval 'sub Tcl_SetHashValue {
	    local($h, $value) = @_;
	    eval "(($h)-> &clientData = ( &ClientData) ($value))";
	}' unless defined(&Tcl_SetHashValue);
	eval 'sub Tcl_GetHashKey {
	    local($tablePtr, $h) = @_;
	    eval "( ((($tablePtr)-> &keyType ==  &TCL_ONE_WORD_KEYS) ? ($h)-> &key. &oneWordValue : ($h)-> &key. &string))";
	}' unless defined(&Tcl_GetHashKey);
	eval 'sub Tcl_FindHashEntry {
	    local($tablePtr, $key) = @_;
	    eval "(*(($tablePtr)-> &findProc))($tablePtr, $key)";
	}' unless defined(&Tcl_FindHashEntry);
	eval 'sub Tcl_CreateHashEntry {
	    local($tablePtr, $key, $newPtr) = @_;
	    eval "(*(($tablePtr)-> &createProc))($tablePtr, $key, $newPtr)";
	}' unless defined(&Tcl_CreateHashEntry);
	eval 'sub TCL_DONT_WAIT () {(1<<1);}' unless defined(&TCL_DONT_WAIT);
	eval 'sub TCL_WINDOW_EVENTS () {(1<<2);}' unless defined(&TCL_WINDOW_EVENTS);
	eval 'sub TCL_FILE_EVENTS () {(1<<3);}' unless defined(&TCL_FILE_EVENTS);
	eval 'sub TCL_TIMER_EVENTS () {(1<<4);}' unless defined(&TCL_TIMER_EVENTS);
	eval 'sub TCL_IDLE_EVENTS () {(1<<5);}' unless defined(&TCL_IDLE_EVENTS);
	eval 'sub TCL_ALL_EVENTS () {(~ &TCL_DONT_WAIT);}' unless defined(&TCL_ALL_EVENTS);
	eval 'sub TCL_READABLE () {(1<<1);}' unless defined(&TCL_READABLE);
	eval 'sub TCL_WRITABLE () {(1<<2);}' unless defined(&TCL_WRITABLE);
	eval 'sub TCL_EXCEPTION () {(1<<3);}' unless defined(&TCL_EXCEPTION);
	eval 'sub TCL_STDIN () {(1<<1);}' unless defined(&TCL_STDIN);
	eval 'sub TCL_STDOUT () {(1<<2);}' unless defined(&TCL_STDOUT);
	eval 'sub TCL_STDERR () {(1<<3);}' unless defined(&TCL_STDERR);
	eval 'sub TCL_ENFORCE_MODE () {(1<<4);}' unless defined(&TCL_ENFORCE_MODE);
	eval 'sub TCL_MODE_BLOCKING () {0;}' unless defined(&TCL_MODE_BLOCKING);
	eval 'sub TCL_MODE_NONBLOCKING () {1;}' unless defined(&TCL_MODE_NONBLOCKING);
	eval 'sub TCL_UNIX_FD () {1;}' unless defined(&TCL_UNIX_FD);
	eval 'sub TCL_MAC_FILE () {2;}' unless defined(&TCL_MAC_FILE);
	eval 'sub TCL_MAC_SOCKET () {3;}' unless defined(&TCL_MAC_SOCKET);
	eval 'sub TCL_WIN_PIPE () {4;}' unless defined(&TCL_WIN_PIPE);
	eval 'sub TCL_WIN_FILE () {5;}' unless defined(&TCL_WIN_FILE);
	eval 'sub TCL_WIN_SOCKET () {6;}' unless defined(&TCL_WIN_SOCKET);
	eval 'sub TCL_WIN_CONSOLE () {7;}' unless defined(&TCL_WIN_CONSOLE);
	eval 'sub TCL_WIN32S_PIPE () {8;}' unless defined(&TCL_WIN32S_PIPE);
	eval 'sub Tcl_Ckalloc () { &Tcl_Alloc;}' unless defined(&Tcl_Ckalloc);
	eval 'sub Tcl_Ckfree () { &Tcl_Free;}' unless defined(&Tcl_Ckfree);
	eval 'sub Tcl_Ckrealloc () { &Tcl_Realloc;}' unless defined(&Tcl_Ckrealloc);
	eval 'sub Tcl_Return () { &Tcl_SetResult;}' unless defined(&Tcl_Return);
	eval 'sub Tcl_TildeSubst () { &Tcl_TranslateFileName;}' unless defined(&Tcl_TildeSubst);
    }
}
1;
